package es.uca.webservices.gamera.ggen.individuals;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import es.uca.webservices.gamera.api.ComparisonResult;
import es.uca.webservices.gamera.api.ComparisonResults;
import es.uca.webservices.gamera.api.GAIndividual;

/**
 * Data store for all the individuals generated by the genetic algorithm, divided by generation. It also
 * implements several useful queries for removing duplicates that have the same components or that kill
 * the same subset of mutants.
 *
 * @author alvaro, Antonio Garcia Dominguez
 */
public class GgenHistory {

    /**
     * A single entry in the algorithm's history, containing all the information from a single generation.
     */

    public static class Entry {
        private final GgenPopulation population;
        private final ComparisonResults[] comparisonsByProgram;

        public Entry(GgenPopulation population, ComparisonResults[] comparisonsByProgram) {
            this.population = population;
            this.comparisonsByProgram = Arrays.copyOf(comparisonsByProgram, comparisonsByProgram.length);
        }

        public GgenPopulation getPopulation() {
            return population;
        }

        /**
         * Returns the results of the comparisons between the original program and the mutants.
         * The <code>i</code>-th entry in the returned array corresponds to the row of comparison
         * results from the <code>i</code>-th mutant of the original program. Within a certain row,
         * the <code>j</code>-th column corresponds to the result obtain by the <code>j</code>-th
         * test case.
         */
        public ComparisonResults[] getComparisonsByProgram() {
            return comparisonsByProgram;
        }

        /**
         * <p>Returns the results of the comparisons between the original program and the mutants.
         * In this case, the <code>i</code>-th entry in the returned array corresponds to the
         * comparison results between the original program and each of the mutants for the
         * <code>i</code>-th test case. Within each row, the <code>j</code>-th row refers to
         * the mutant in the <code>j</code>-th position, according to a lexicographical traversal
         * of all available mutants.</p>
         *
         * <p>Effectively, this is a transpose of the matrix returned by {@link #getComparisonsByProgram()}.
         * Computing it requires traversing the original matrix.</p>
         */
        public ComparisonResult[][] getComparisonsByTestCase() {
            if (comparisonsByProgram == null || comparisonsByProgram.length == 0) {
                return new ComparisonResult[0][];
            }

            final int nProgramMutants = comparisonsByProgram.length;
            final int nTestCases = comparisonsByProgram[0].getRow().length;
            final ComparisonResult[][] matrix = new ComparisonResult[nTestCases][];
            for (int iTestCase = 0; iTestCase < nTestCases; ++iTestCase) {
                final ComparisonResult[] testCaseComparisons = new ComparisonResult[nProgramMutants];
                for (int iProgramMutant = 0; iProgramMutant < nProgramMutants; ++iProgramMutant) {
                    testCaseComparisons[iProgramMutant] = comparisonsByProgram[iProgramMutant].getRow()[iTestCase];
                }

                matrix[iTestCase] = testCaseComparisons;
            }

            return matrix;
        }

        /**
         * Returns a map from each individual in the population to the comparison results obtained
         * by running it against each program mutant, according to {@link #getComparisonsByTestCase()}.
         * Repeated individuals (with the same components) are removed.
         */
        public Map<GgenIndividual, ComparisonResult[]> getComparisonsByUniqueTestCase() {
            final  List<GgenIndividual> individuals = population.getPopulation();
            final ComparisonResult[][] comparisons = getComparisonsByTestCase();
            assert individuals.size() == comparisons.length;

            final Map<GgenIndividual, ComparisonResult[]> m = new LinkedHashMap<GgenIndividual, ComparisonResult[]>();
            for (int i = 0; i < comparisons.length; ++i) {
                m.put(individuals.get(i), comparisons[i]);
            }

            return m;
        }

        /**
         * Returns a list of sets with the program mutants that were killed by each test case in this
         * entry.
         */
        public Map<GgenIndividual, Set<GAIndividual>> getProgramMutantsKilledByTestCase() {
            // Initially, test cases do not kill any program mutant
            final Map<GgenIndividual, Set<GAIndividual>> result = new HashMap<GgenIndividual, Set<GAIndividual>>();
            final int nTestCases = population.getPopulationSize();
            for (int i = 0; i < nTestCases; ++i) {
                result.put(population.getIndividual(i), new HashSet<GAIndividual>());
            }

            // Check the results from running each program mutant against the test cases
            // and add the program mutant to the test cases that kill it.
            for (ComparisonResults programComparisons : comparisonsByProgram) {
                final GAIndividual program = programComparisons.getIndividual();
                final ComparisonResult[] row = programComparisons.getRow();
                for (int i = 0; i < row.length; ++i) {
                    if (row[i] == ComparisonResult.DIFFERENT_OUTPUT) {
                        final GgenIndividual ind = population.getIndividual(i);
                        result.get(ind).add(program);
                    }
                }
            }

            return result;
        }

    }

    private final List<Entry> entries = new ArrayList<Entry>();
    private final Map<GgenIndividual, ComparisonResult[]> allComparisonsByUniqueTestCase = new LinkedHashMap<GgenIndividual, ComparisonResult[]>();

    /**
     * Adds the information from the latest population to the history.
     */
    public void add(final GgenPopulation population, final ComparisonResults[] comparisons) {
        assert population  != null : "population != null";
        assert comparisons != null : "comparisons != null";
        assert population.getPopulation().isEmpty() == (comparisons.length == 0) : "If the population is empty, the comparisons should also be empty";
        assert population.getPopulation().isEmpty() || comparisons[0].getRow().length == population.getPopulationSize()
                : "The comparison matrix should have as many columns as there are test cases";

        final Entry entry = new Entry(population, comparisons);
		entries.add(entry);
		allComparisonsByUniqueTestCase.putAll(entry.getComparisonsByUniqueTestCase());
    }

    /**
     * Returns the identifier of the current generation.
     * @return 0 if no generation has been run yet, or a number N > 1 indicating that N generations have been run.
     */
    public int currentGeneration() {
        return entries.size();
    }

    /**
     * Returns an iterable object with all the entries so far in the history of the algorithm.
     */
    public Iterable<Entry> getEntries() {
        return entries;
    }

	/**
     * Returns the <code>n</code>-th entry generated by the algorithm.
     *
     * @param n Generation number, starting from 1 and less than or equal to the number of generations produced.
     * @throws IndexOutOfBoundsException The <code>n</code>-th population has not been generated yet.
     */
    public Entry getEntry(int n) {
        return entries.get(n - 1);
    }

    /**
     * Returns the collection of individuals produced during the <code>n</code>-th generation, if it exists.
     * Otherwise, returns an empty collection.
     * @param n Generation number, starting from 1.
     */
    public Collection<GgenIndividual> individualsFrom(int n) {
        if (n > 0 && n <= entries.size()) {
            return getEntry(n).getPopulation().getPopulation();
        } else {
            return new ArrayList<GgenIndividual>();
        }
    }

    /**
     * Returns the last population produced by the algorithm, or <code>null</code> if none has been generated yet.
     */
    public Entry lastEntry() {
        return entries.isEmpty() ? null : getEntry(entries.size());
    }

    /**
     * <p>Returns a set of all the individuals generated so far by the algorithm, removing duplicates
     * that have the same components and the same values in them. Each element also has the comparison
     * results produced while running it against the program mutants.</p>
     */
    public Map<GgenIndividual, ComparisonResult[]> allUniqueIndividualsByComponentValues() {
    	return allComparisonsByUniqueTestCase;
    }

    /**
     * Returns a set of all the individuals generated so far by the algorithm, removing duplicates
     * that kill the exact same set of mutants.
     *
     * Note: the keys in the returned map are lists and not just regular arrays due to the way in
     * which hash codes are computed in arrays. Array hashcodes are based on the reference, not
     * on their contents, so several individuals killed by the same test cases would be still
     * considered to be different from each other.
     */
    public Map<List<ComparisonResult>, GgenIndividual> allUniqueIndividualsByComparisonResults() {
        final Map<List<ComparisonResult>, GgenIndividual> result = new LinkedHashMap<List<ComparisonResult>, GgenIndividual>();
		for (Map.Entry<GgenIndividual, ComparisonResult[]> cmp : allComparisonsByUniqueTestCase.entrySet()) {
			final ArrayList<ComparisonResult> comparisons = new ArrayList<ComparisonResult>(Arrays.asList(cmp.getValue()));
			result.put(comparisons, cmp.getKey());
		}
        return result;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        int count = 0, generation = 1;

        for (Entry entry : entries) {
            if (generation > 1) {
                sb.append('\n');
            }
            sb.append("Generation ");
            sb.append(generation++);
            sb.append("\n");

            // Header for this generation - fixed fields + column per mutant
            sb.append("index\t{fitness components}");
            for (ComparisonResults r : entry.getComparisonsByProgram()) {
            	sb.append('\t');
            	sb.append(r.getIndividual().individualFieldsToString());
            }

            final List<GgenIndividual> population = entry.getPopulation().getPopulation();
            final ComparisonResult[][] comparisonResultsByTestCase = entry.getComparisonsByTestCase();
            for (int i = 0; i < population.size(); ++i) {
                sb.append('\n');
                sb.append(count++);
                sb.append('\t');
                sb.append(population.get(i));
                for (ComparisonResult r : comparisonResultsByTestCase[i]) {
                    sb.append('\t');
                    sb.append(r.getValue());
                }
            }
        }
        return sb.toString();
    }
}
